"""Add namespaced groups

Revision ID: 29c20e85e5fe
Revises: 236df7dfaf3d
Create Date: 2015-06-22 18:01:04.749508

"""

# revision identifiers, used by Alembic.
revision = '29c20e85e5fe'
down_revision = '236df7dfaf3d'

from alembic import op
import sqlalchemy as sa


def upgrade():
    ### commands auto generated by Alembic - please adjust! ###
    op.create_table('group_acl',
    sa.Column('group_id', sa.Integer(), nullable=False),
    sa.Column('user_id', sa.Integer(), nullable=False),
    sa.ForeignKeyConstraint(['group_id'], ['package_group.id'], ondelete='CASCADE'),
    sa.ForeignKeyConstraint(['user_id'], ['user.id'], ondelete='CASCADE'),
    sa.PrimaryKeyConstraint('group_id', 'user_id')
    )
    op.add_column(u'package_group', sa.Column('namespace', sa.String(), nullable=True))
    op.create_index('ix_package_group_name', 'package_group', ['namespace', 'name'], unique=True)
    ### end Alembic commands ###


def downgrade():
    ### commands auto generated by Alembic - please adjust! ###
    op.drop_index('ix_package_group_name', table_name='package_group')
    op.drop_column(u'package_group', 'namespace')
    op.drop_table('group_acl')
    ### end Alembic commands ###
